Package fr.gouv.vitam.logbook.common.server

# Interface LogbookDbAccess

All Known Implementing Classes:
  `LogbookMongoDbAccessImpl`

public interface LogbookDbAccess
MongoDbAccess interface

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `bulkInsert(String idOp, LogbookCollections lifecycleUnit, List<? extends LogbookLifeCycleModel> logbookLifeCycleModels)`
  `void`
  `close()`
  Close database access
  `void`
  `createLogbookLifeCycleObjectGroup(LogbookLifeCycleObjectGroupInProcess logbookLifeCycleObjectGrouptInProcess)`
  Creates ObjectGroup lifeCycle from a LogbookLifeCycleObjectGroupInProcess instance
  `void`
  `createLogbookLifeCycleObjectGroup(String operationId, LogbookLifeCycleObjectGroupParameters... lifecycleItems)`
  Create one Logbook LifeCycle with already multiple sub-events
  `void`
  `createLogbookLifeCycleUnit(LogbookLifeCycleUnitInProcess logbookLifeCycleUnitInProcess)`
  Creates Unit lifeCycle from a LogbookLifeCycleUnitInProcess instance
  `void`
  `createLogbookLifeCycleUnit(String operationId, LogbookLifeCycleUnitParameters... lifecycleItems)`
  Create one Logbook LifeCycle with already multiple sub-events
  `void`
  `createLogbookOperation(String operationId, LogbookOperationParameters... operationItems)`
  Create one Logbook Operation with already multiple sub-events
  `void`
  `deleteCollectionForTesting(LogbookCollections collection)`
  Delete logbook collection
  `boolean`
  `existsLogbookLifeCycleObjectGroup(String lifecycleItem)`
  Check if one eventIdentifier for Lifecycle exists already
  `boolean`
  `existsLogbookLifeCycleObjectGroupInProcess(String lifecycleItem)`
  Check if one eventIdentifier for Lifecycle exists already
  `boolean`
  `existsLogbookLifeCycleUnit(String lifecycleItem)`
  Check if one eventIdentifier for Lifecycle exists already
  `boolean`
  `existsLogbookLifeCycleUnitInProcess(String lifecycleItem)`
  Check if one eventIdentifier for Lifecycle exists already
  `boolean`
  `existsLogbookOperation(String operationItem)`
  Check if one eventIdentifier for Operation exists already
  `String`
  `getInfo()`
  Get information on a Database
  `LogbookLifeCycleObjectGroupInProcess`
  `getLogbookLifeCycleObjectGroupInProcess(String objectGroupId)`
  Gets ObjectGroup LifeCycle In process
  `com.mongodb.client.MongoCursor<LogbookLifeCycleObjectGroup>`
  `getLogbookLifeCycleObjectGroupsFull(LogbookCollections collection, Select select)`
  Get a list of Logbook LifeCycle through Closeable MongoCursor
  `com.mongodb.client.MongoCursor<LogbookLifeCycle<?>>`
  `getLogbookLifeCycles(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, LogbookCollections collection)`
  Get a list of Logbook LifeCycles through Closeable MongoCursor
  `LogbookLifeCycleUnitInProcess`
  `getLogbookLifeCycleUnitInProcess(String unitId)`
  Get Unit LifeCycle In process
  `com.mongodb.client.MongoCursor<LogbookLifeCycleUnit>`
  `getLogbookLifeCycleUnitsFull(LogbookCollections collection, Select select)`
  Get a list of Logbook LifeCycle through Closeable MongoCursor
  `long`
  `getLogbookLifeCyleObjectGroupInProcessSize()`
  `long`
  `getLogbookLifeCyleObjectGroupSize()`
  `long`
  `getLogbookLifeCyleUnitInProcessSize()`
  `long`
  `getLogbookLifeCyleUnitSize()`
  `LogbookOperation`
  `getLogbookOperationById(String eventIdentifierProcess)`
  Get one Operation
  `LogbookOperation`
  `getLogbookOperationById(String eventIdentifierProcess, com.fasterxml.jackson.databind.JsonNode query, boolean slice, boolean crossTenant)`
  Get one Operation
  `VitamMongoCursor<LogbookOperation>`
  `getLogbookOperations(com.fasterxml.jackson.databind.JsonNode select, boolean sliced)`
  `VitamMongoCursor<LogbookOperation>`
  `getLogbookOperations(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, boolean crossTenant)`
  Get a list of Logbook Operation through Closeable MongoCursor
  `long`
  `getLogbookOperationSize()`
  `LogbookLifeCycle<?>`
  `getOneLogbookLifeCycle(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, LogbookCollections collection)`
  Get a list of Logbook LifeCycles through Closeable MongoCursor
  `void`
  `rollbackLogbookLifeCycleObjectGroup(String idOperation, String lifecycleItem)`
  Rollback one Logbook LifeCycle
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `rollbackLogbookLifeCycleUnit(String idOperation, String lifecycleItem)`
  Rollback one Logbook LifeCycle
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `rollBackObjectGroupLifeCyclesByOperation(String operationId)`
  Rolls back all the created objectGroups lifeCycles during a given operation
  `void`
  `rollBackUnitLifeCyclesByOperation(String operationId)`
  Rolls back all the created unit lifeCycles during a given operation
  `void`
  `updateLogbookLifeCycleBulk(LogbookCollections collection, List<LogbookLifeCycleParametersBulk> logbookLifeCycleParametersBulk)`
  `void`
  `updateLogbookLifeCycleObjectGroup(LogbookLifeCycleObjectGroupParameters... lifecycleItems)`
  Update one Logbook LifeCycle with multiple sub-events
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `updateLogbookLifeCycleObjectGroup(LogbookLifeCycleObjectGroupInProcess logbookLifeCycleObjectGrouptInProcess)`
  Updates ObjectGroup lifeCycle from a LogbookLifeCycleObjectGroupInProcess instance
  `void`
  `updateLogbookLifeCycleObjectGroup(String idOperation, String idLfc, LogbookLifeCycleObjectGroupParameters lifecycleItem)`
  Update one Logbook LifeCycle
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `updateLogbookLifeCycleObjectGroup(String idOperation, String idLfc, LogbookLifeCycleObjectGroupParameters lifecycleItem, boolean commit)`
  Update one Logbook LifeCycle
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `updateLogbookLifeCycleUnit(LogbookLifeCycleUnitParameters... lifecycleItems)`
  Update one Logbook LifeCycle with multiple sub-events
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `updateLogbookLifeCycleUnit(LogbookLifeCycleUnitInProcess logbookLifeCycleUnitInProcess)`
  Updates Unit lifeCycle from a LogbookLifeCycleUnitInProcess instance
  `void`
  `updateLogbookLifeCycleUnit(String idOperation, String idLfc, LogbookLifeCycleUnitParameters lifecycleItem)`
  Update one Logbook LifeCycle
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `updateLogbookLifeCycleUnit(String idOperation, String idLfc, LogbookLifeCycleUnitParameters lifecycleItem, boolean commit)`
  Update one Logbook LifeCycle (in progress or committed
  It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
  `void`
  `updateLogbookOperation(String operationId, LogbookOperationParameters... operationItems)`
  Update one Logbook Operation with multiple sub-events
  It adds this new entry within the very same Logbook Operaton entry in "events" array.

- ## Method Details

  - ### close

    void close()
    Close database access

  - ### getLogbookOperationSize

    long getLogbookOperationSize() throws LogbookDatabaseException, LogbookNotFoundException
    Returns:
      the current number of Logbook Operation
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`

  - ### getLogbookLifeCyleUnitSize

    long getLogbookLifeCyleUnitSize() throws LogbookDatabaseException, LogbookNotFoundException
    Returns:
      the current number of Logbook LifeCyle
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`

  - ### getLogbookLifeCyleObjectGroupSize

    long getLogbookLifeCyleObjectGroupSize()
    Returns:
      the current number of Logbook LifeCyle

  - ### existsLogbookOperation

    boolean existsLogbookOperation(String operationItem) throws LogbookDatabaseException
    Check if one eventIdentifier for Operation exists already
    Parameters:
      `operationItem` -
    Returns:
      True if one LogbookOperation exists with this id
    Throws:
      `LogbookDatabaseException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### existsLogbookLifeCycleUnit

    boolean existsLogbookLifeCycleUnit(String lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException
    Check if one eventIdentifier for Lifecycle exists already
    Parameters:
      `lifecycleItem` -
    Returns:
      True if one LogbookLibeCycle exists with this id
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### existsLogbookLifeCycleObjectGroup

    boolean existsLogbookLifeCycleObjectGroup(String lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException
    Check if one eventIdentifier for Lifecycle exists already
    Parameters:
      `lifecycleItem` -
    Returns:
      True if one LogbookLibeCycle exists with this id
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### getLogbookOperationById

    LogbookOperation getLogbookOperationById(String eventIdentifierProcess) throws LogbookDatabaseException, LogbookNotFoundException
    Get one Operation
    Parameters:
      `eventIdentifierProcess` -
    Returns:
      the corresponding LogbookOperation if it exists
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `VitamDBException`

  - ### getLogbookOperationById

    LogbookOperation getLogbookOperationById(String eventIdentifierProcess, com.fasterxml.jackson.databind.JsonNode query, boolean slice, boolean crossTenant) throws LogbookDatabaseException, LogbookNotFoundException
    Get one Operation
    Parameters:
      `eventIdentifierProcess` -
      `query` -
      `slice` -
      `crossTenant` -
    Returns:
      the corresponding LogbookOperation if it exists
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `VitamDBException`

  - ### updateLogbookLifeCycleUnit

    void updateLogbookLifeCycleUnit(String idOperation, String idLfc, LogbookLifeCycleUnitParameters lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Update one Logbook LifeCycle
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `idOperation` -
      `idLfc` -
      `lifecycleItem` -
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `LogbookAlreadyExistsException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### updateLogbookLifeCycleUnit

    void updateLogbookLifeCycleUnit(String idOperation, String idLfc, LogbookLifeCycleUnitParameters lifecycleItem, boolean commit) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Update one Logbook LifeCycle (in progress or committed
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `idOperation` -
      `idLfc` -
      `lifecycleItem` -
      `commit` - if true update committed LFC else update in progress LFC
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `LogbookAlreadyExistsException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### updateLogbookLifeCycleObjectGroup

    void updateLogbookLifeCycleObjectGroup(String idOperation, String idLfc, LogbookLifeCycleObjectGroupParameters lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Update one Logbook LifeCycle
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `idOperation` -
      `idLfc` -
      `lifecycleItem` -
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `LogbookAlreadyExistsException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### updateLogbookLifeCycleObjectGroup

    void updateLogbookLifeCycleObjectGroup(String idOperation, String idLfc, LogbookLifeCycleObjectGroupParameters lifecycleItem, boolean commit) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Update one Logbook LifeCycle
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `idOperation` -
      `idLfc` -
      `lifecycleItem` -
      `commit` - if true update is done on committed collection otherwise on inProcess one
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `LogbookAlreadyExistsException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### rollbackLogbookLifeCycleUnit

    void rollbackLogbookLifeCycleUnit(String idOperation, String lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException
    Rollback one Logbook LifeCycle
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `idOperation` -
      `lifecycleItem` -
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### rollbackLogbookLifeCycleObjectGroup

    void rollbackLogbookLifeCycleObjectGroup(String idOperation, String lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException
    Rollback one Logbook LifeCycle
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `idOperation` -
      `lifecycleItem` -
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### createLogbookOperation

    void createLogbookOperation(String operationId, LogbookOperationParameters... operationItems) throws LogbookDatabaseException, LogbookAlreadyExistsException
    Create one Logbook Operation with already multiple sub-events
    Parameters:
      `operationItems` - with first and next events to add/update
    Throws:
      `IllegalArgumentException` - if first argument is null or null mandatory parameters for all
      `LogbookDatabaseException`
      `LogbookAlreadyExistsException`

  - ### createLogbookLifeCycleUnit

    void createLogbookLifeCycleUnit(String operationId, LogbookLifeCycleUnitParameters... lifecycleItems) throws LogbookDatabaseException, LogbookAlreadyExistsException
    Create one Logbook LifeCycle with already multiple sub-events
    Parameters:
      `lifecycleItems` - with first and next events to add/update
    Throws:
      `IllegalArgumentException` - if first argument is null or null mandatory parameters for all
      `LogbookDatabaseException`
      `LogbookAlreadyExistsException`

  - ### createLogbookLifeCycleObjectGroup

    void createLogbookLifeCycleObjectGroup(String operationId, LogbookLifeCycleObjectGroupParameters... lifecycleItems) throws LogbookDatabaseException, LogbookAlreadyExistsException
    Create one Logbook LifeCycle with already multiple sub-events
    Parameters:
      `lifecycleItems` - with first and next events to add/update
    Throws:
      `IllegalArgumentException` - if first argument is null or null mandatory parameters for all
      `LogbookDatabaseException`
      `LogbookAlreadyExistsException`

  - ### updateLogbookOperation

    void updateLogbookOperation(String operationId, LogbookOperationParameters... operationItems) throws LogbookDatabaseException, LogbookNotFoundException
    Update one Logbook Operation with multiple sub-events
    It adds this new entry within the very same Logbook Operaton entry in "events" array.
    Parameters:
      `operationId` -
      `operationItems` -
    Throws:
      `IllegalArgumentException` - if parameter has null or empty mandatory values
      `LogbookDatabaseException`
      `LogbookNotFoundException`

  - ### updateLogbookLifeCycleUnit

    void updateLogbookLifeCycleUnit(LogbookLifeCycleUnitParameters... lifecycleItems) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Update one Logbook LifeCycle with multiple sub-events
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `lifecycleItems` -
    Throws:
      `IllegalArgumentException` - if parameter has null or empty mandatory values
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `LogbookAlreadyExistsException`

  - ### updateLogbookLifeCycleObjectGroup

    void updateLogbookLifeCycleObjectGroup(LogbookLifeCycleObjectGroupParameters... lifecycleItems) throws LogbookDatabaseException, LogbookNotFoundException, LogbookAlreadyExistsException
    Update one Logbook LifeCycle with multiple sub-events
    It adds this new entry within the very same Logbook LifeCycle entry in "events" array.
    Parameters:
      `lifecycleItems` -
    Throws:
      `IllegalArgumentException` - if parameter has null or empty mandatory values
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `LogbookAlreadyExistsException`

  - ### getLogbookOperations

    VitamMongoCursor<LogbookOperation> getLogbookOperations(com.fasterxml.jackson.databind.JsonNode select, boolean sliced) throws LogbookDatabaseException, VitamDBException
    Throws:
      `LogbookDatabaseException`
      `VitamDBException`

  - ### getLogbookOperations

    VitamMongoCursor<LogbookOperation> getLogbookOperations(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, boolean crossTenant) throws LogbookDatabaseException, VitamDBException
    Get a list of Logbook Operation through Closeable MongoCursor
    Parameters:
      `select` -
      `sliced` - If true will return the first and last events only
    Returns:
      the Closeable MongoCursor of LogbookOperation
    Throws:
      `IllegalArgumentException` - if argument is null or empty
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `VitamDBException`

  - ### getOneLogbookLifeCycle

    LogbookLifeCycle<?> getOneLogbookLifeCycle(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, LogbookCollections collection) throws LogbookDatabaseException, LogbookNotFoundException, VitamDBException
    Get a list of Logbook LifeCycles through Closeable MongoCursor
    Parameters:
      `select` -
      `sliced` -
      `collection` - the collection on which the select operation will be done : Production collection (LIFECYCLE_UNIT/LIFECYCLE_OBJECT_GROUP) or Working collection (LIFECYCLE_UNIT_IN_PROCESS/LIFECYCLE_OBJECT_GROUP_IN_PROCESS)
    Returns:
      the Closeable MongoCursor of LogbookLifeCycle
    Throws:
      `IllegalArgumentException` - if argument is null or empty
      `LogbookDatabaseException` - if more than one result
      `LogbookNotFoundException` - if no result
      `VitamDBException`

  - ### getLogbookLifeCycles

    com.mongodb.client.MongoCursor<LogbookLifeCycle<?>> getLogbookLifeCycles(com.fasterxml.jackson.databind.JsonNode select, boolean sliced, LogbookCollections collection) throws LogbookDatabaseException, LogbookNotFoundException, VitamDBException
    Get a list of Logbook LifeCycles through Closeable MongoCursor
    Parameters:
      `select` -
      `sliced` -
      `collection` - the collection on which the select operation will be done : Production collection (LIFECYCLE_UNIT/LIFECYCLE_OBJECT_GROUP) or Working collection (LIFECYCLE_UNIT_IN_PROCESS/LIFECYCLE_OBJECT_GROUP_IN_PROCESS)
    Returns:
      the Closeable MongoCursor of LogbookLifeCycle
    Throws:
      `IllegalArgumentException` - if argument is null or empty
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `VitamDBException`

  - ### getLogbookLifeCycleUnitsFull

    com.mongodb.client.MongoCursor<LogbookLifeCycleUnit> getLogbookLifeCycleUnitsFull(LogbookCollections collection, Select select) throws LogbookDatabaseException
    Get a list of Logbook LifeCycle through Closeable MongoCursor
    Parameters:
      `collection` - the collection on which the select operation will be done : Production collection (LIFECYCLE_UNIT) or Working collection (LIFECYCLE_UNIT_IN_PROCESS)
      `select` -
    Returns:
      the Closeable MongoCursor of LogbookLifeCycle
    Throws:
      `IllegalArgumentException` - if argument is null or empty
      `LogbookDatabaseException`

  - ### getLogbookLifeCycleObjectGroupsFull

    com.mongodb.client.MongoCursor<LogbookLifeCycleObjectGroup> getLogbookLifeCycleObjectGroupsFull(LogbookCollections collection, Select select) throws LogbookDatabaseException
    Get a list of Logbook LifeCycle through Closeable MongoCursor
    Parameters:
      `collection` - the collection on which the select operation will be done : Production collection (LIFECYCLE_OBJECT_GROUP) or Working collection (LIFECYCLE_OBJECT_GROUP_IN_PROCESS)
      `select` -
    Returns:
      the Closeable MongoCursor of LogbookLifeCycle
    Throws:
      `IllegalArgumentException` - if argument is null or empty
      `LogbookDatabaseException`

  - ### deleteCollectionForTesting

    void deleteCollectionForTesting(LogbookCollections collection) throws DatabaseException, LogbookExecutionException
    Delete logbook collection
    Parameters:
      `collection` - the logbook collection to delete
    Throws:
      `DatabaseException` - thrown when error on delete
      `LogbookExecutionException`

  - ### getLogbookLifeCycleUnitInProcess

    LogbookLifeCycleUnitInProcess getLogbookLifeCycleUnitInProcess(String unitId) throws LogbookDatabaseException, LogbookNotFoundException
    Get Unit LifeCycle In process
    Parameters:
      `unitId` - the unit id
    Returns:
      the corresponding LogbookLifeCycleUnitInProcess if it exists
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### getLogbookLifeCycleObjectGroupInProcess

    LogbookLifeCycleObjectGroupInProcess getLogbookLifeCycleObjectGroupInProcess(String objectGroupId) throws LogbookDatabaseException, LogbookNotFoundException
    Gets ObjectGroup LifeCycle In process
    Parameters:
      `objectGroupId` - the object group id
    Returns:
      the corresponding LogbookLifeCycleObjectGroupInProcess if it exists
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### createLogbookLifeCycleUnit

    void createLogbookLifeCycleUnit(LogbookLifeCycleUnitInProcess logbookLifeCycleUnitInProcess) throws LogbookDatabaseException, LogbookAlreadyExistsException
    Creates Unit lifeCycle from a LogbookLifeCycleUnitInProcess instance
    Parameters:
      `logbookLifeCycleUnitInProcess` - a LogbookLifeCycleUnitInProcess instance
    Throws:
      `LogbookAlreadyExistsException`
      `LogbookDatabaseException`

  - ### createLogbookLifeCycleObjectGroup

    void createLogbookLifeCycleObjectGroup(LogbookLifeCycleObjectGroupInProcess logbookLifeCycleObjectGrouptInProcess) throws LogbookDatabaseException, LogbookAlreadyExistsException
    Creates ObjectGroup lifeCycle from a LogbookLifeCycleObjectGroupInProcess instance
    Parameters:
      `logbookLifeCycleObjectGrouptInProcess` -
    Throws:
      `LogbookAlreadyExistsException`
      `LogbookDatabaseException`

  - ### updateLogbookLifeCycleUnit

    void updateLogbookLifeCycleUnit(LogbookLifeCycleUnitInProcess logbookLifeCycleUnitInProcess) throws LogbookDatabaseException, LogbookNotFoundException
    Updates Unit lifeCycle from a LogbookLifeCycleUnitInProcess instance
    Parameters:
      `logbookLifeCycleUnitInProcess` - a LogbookLifeCycleUnitInProcess instance
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`

  - ### updateLogbookLifeCycleObjectGroup

    void updateLogbookLifeCycleObjectGroup(LogbookLifeCycleObjectGroupInProcess logbookLifeCycleObjectGrouptInProcess) throws LogbookDatabaseException, LogbookNotFoundException
    Updates ObjectGroup lifeCycle from a LogbookLifeCycleObjectGroupInProcess instance
    Parameters:
      `logbookLifeCycleObjectGrouptInProcess` - a LogbookLifeCycleObjectGroupInProcess instance
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`

  - ### rollBackUnitLifeCyclesByOperation

    void rollBackUnitLifeCyclesByOperation(String operationId) throws LogbookNotFoundException, LogbookDatabaseException
    Rolls back all the created unit lifeCycles during a given operation
    Parameters:
      `operationId` - an operation id
    Throws:
      `LogbookNotFoundException`
      `LogbookDatabaseException`

  - ### rollBackObjectGroupLifeCyclesByOperation

    void rollBackObjectGroupLifeCyclesByOperation(String operationId) throws LogbookNotFoundException, LogbookDatabaseException
    Rolls back all the created objectGroups lifeCycles during a given operation
    Parameters:
      `operationId` - an operation Id
    Throws:
      `LogbookNotFoundException`
      `LogbookDatabaseException`

  - ### getLogbookLifeCyleUnitInProcessSize

    long getLogbookLifeCyleUnitInProcessSize()
    Returns:
      the current number of LogbookLifeCyle created in working unit collection

  - ### getLogbookLifeCyleObjectGroupInProcessSize

    long getLogbookLifeCyleObjectGroupInProcessSize()
    Returns:
      the current number of LogbookLifeCyle created in working objectGroup collection

  - ### existsLogbookLifeCycleUnitInProcess

    boolean existsLogbookLifeCycleUnitInProcess(String lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException
    Check if one eventIdentifier for Lifecycle exists already
    Parameters:
      `lifecycleItem` -
    Returns:
      True if one LogbookLibeCycle exists with this id
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### existsLogbookLifeCycleObjectGroupInProcess

    boolean existsLogbookLifeCycleObjectGroupInProcess(String lifecycleItem) throws LogbookDatabaseException, LogbookNotFoundException
    Check if one eventIdentifier for Lifecycle exists already
    Parameters:
      `lifecycleItem` -
    Returns:
      True if one LogbookLibeCycle exists with this id
    Throws:
      `LogbookDatabaseException`
      `LogbookNotFoundException`
      `IllegalArgumentException` - if parameter has null or empty mandatory values

  - ### getInfo

    String getInfo()
    Get information on a Database
    Returns:
      information on the database

  - ### bulkInsert

    void bulkInsert(String idOp, LogbookCollections lifecycleUnit, List<? extends LogbookLifeCycleModel> logbookLifeCycleModels) throws DatabaseException
    Throws:
      `DatabaseException`

  - ### updateLogbookLifeCycleBulk

    void updateLogbookLifeCycleBulk(LogbookCollections collection, List<LogbookLifeCycleParametersBulk> logbookLifeCycleParametersBulk)